object	AISeaGoods;

void DeleteSeaGoodsEnvironment()
{
	DeleteClass(&AISeaGoods);

	DelEventHandler(SHIP_DEAD, "AISeaGoods_ShipDead");
}

void CreateSeaGoodsEnvironment()
{
	CreateEntity(&AISeaGoods, "AISeaGoods");
	
	LayerAddObject(SEA_EXECUTE, &AISeaGoods, -1);
	LayerAddObject(SEA_REALIZE, &AISeaGoods, 65532);

	SetEventHandler(SHIP_DEAD, "AISeaGoods_ShipDead", 0);
	SetEventHandler(SHIP_EAT_SWIM_GOOD, "AISeaGoods_ShipEatGood", 0);

	AISeaGoods.ModelsPath = "SwimGoods";
	AISeaGoods.DeleteGoodAnyway = true;
	AISeaGoods.DistanceMultiply = 0.5;
}

void AISeaGoods_ShipDead()
{
	ref rCharacter = GetCharacter(GetEventData());

	aref aGoods; makearef(aGoods, rCharacter.Ship.Cargo.Goods);
	for (int i=0; i<GetAttributesNum(aGoods); i++)
	{
		aref aGood = GetAttributeN(aGoods, i);
		int	iQuantity = sti(GetAttributeValue(aGood));
		ref	rGood = GetGoodByID(GetAttributeName(aGood));

		if (!CheckAttribute(rGood, "Swim")) { continue; }
		
		iQuantity = iQuantity / sti(rGood.Units);
		if (iQuantity <= 1) { continue; }

		if (rand(100) > 90) { continue; }

		int iSwimQuantity = 0; 
		while (iSwimQuantity == 0) { iSwimQuantity = MakeInt(iQuantity / 4 + rand(MakeInt(iQuantity * 2 / 4))); }
		float fTime = stf(rGood.Swim.Time);
		string sModel = rGood.Swim.Model;

		fTime = fTime + (frnd() - 0.5) * fTime / 2.0;

		AISeaGoods_AddGood(rCharacter, GetAttributeName(aGood), sModel, fTime * 60.0, iSwimQuantity);
	}
	       // ccc rescue survivors
       		AISeaGoods.ModelsPath = "LowCharacters";   //path to the crewmodels
       		for (i=1; i<5;  i++)            //runs loop four times
       		{
          		//survivor calculation for tutorial:  iSwimQuantity  = rand(20)  would work, but...
           		iSwimQuantity = MakeInt(1 + rand(sqrt(GetMaxCrewQuantity(rCharacter))));   //... this adds more survivors for bigger ships
          		AISeaGoods_AddGood(rCharacter, "Oil", "Lo_Man", 1000.0,  iSwimQuantity);   //floats a "fake" salvagegood with a sailormodel
       		}
       		AISeaGoods.ModelsPath = "SwimGoods";   //reset path to the salvagemodels
       		// ccc rescue survivors end
}

void AISeaGoods_AddGood(ref rCharacter, string sGood, string sModel, float fTime, int iQuantity)
{
	if (!bSeaActive) return;

	Trace("Add good : " + sGood + ", rCharacter.id = " + rCharacter.id + ", iQuantity = " + iQuantity);

	// calculate random position
          float fAng = stf(rCharacter.Ship.Ang.y);
          float x = (frnd() - 0.5) * 50.0;      // ccc rescue original 20.0; spreads salvage wider
          float z = (frnd() - 0.5) * 90.0;      // ccc rescue  original 40.0
          RotateAroundY(&x, &z, cos(fAng), sin(fAng));

	AISeaGoods.Good = sGood;
	AISeaGoods.Pos.x = stf(rCharacter.Ship.Pos.x) + x;
	AISeaGoods.Pos.z = stf(rCharacter.Ship.Pos.z) + z;
	AISeaGoods.CharIndex = rCharacter.Index;
	AISeaGoods.Time = fTime;
	AISeaGoods.Quantity = iQuantity;
	AISeaGoods.Model = sModel;
	AISeaGoods.Add = "";
}

bool AISeaGoods_ShipEatGood()
{
	object oRes;

	int iCharacterIndex = GetEventData();
	int iGoodCharacterIndex = GetEventData();
	string sGood = GetEventData();
	int iQuantity = GetEventData();

	ref rCharacter = GetCharacter(iCharacterIndex);

	if (iGoodCharacterIndex == iCharacterIndex) return false;
	if (LAi_IsDead(rCharacter)) return false;

	ref rShip = GetShipByID(rCharacter.Ship.Type); // PS
	aref arship; makearef(arship, rCharacter.ship); // PRS3
	ref rGood = GetGoodByID(sGood);

	int iLoad = sti(rCharacter.Ship.Cargo.Load);
	int iCapacity = sti(GetLocalShipAttrib(arship, rShip, "Capacity")); // PRS3
	int iGoodWeight = sti(rGood.Weight);
	int iGoodUnits = sti(rGood.Units);

	int iMaxGoodAllow = (iCapacity - iLoad) / iGoodWeight;
	if (iMaxGoodAllow < 0)	// LDH 19Oct06 fix for weird negative quantities of goods picked up
	{
		trace("Got Goods Error: iCapacity = " + iCapacity + ", iLoad = " + iLoad + ", iGoodWeight = " + iGoodWeight + ", iMaxGoodAllow = " + iMaxGoodAllow + " (set to zero)");
		iMaxGoodAllow = 0;
	}

	string sGoodName = LanguageConvertString(iSeaSectionLang, "seg_" + sGood);

	// ccc Jan07 Directsail, special events that happen if you sail over flotsam of a certain kind
       if (sGood=="Oil")   //Oil, which usually never floats, serves as trigger for events
       {
          SwimGoodEvent(rCharacter,iQuantity);   //new function in CCCdirectsail.c, so that future changes won't affect this common file
          return false;   //aborts the function so that no "oil" goods are added
       }	
	
/* Jan07, original survivor code moved to SwimGoodEvent in CCCdirectsail.c
	// ccc rescue survivors
       if (sGood=="Oil" && iCharacterIndex == GetMainCharacterIndex() )   //runs only for "fake" salvage and the player
       {
          AddCharacterCrew(rCharacter,iQuantity);   //adds crew
	        int tmpLangFileID = LanguageOpenFile("interface_strings.txt");
          Log_SetStringToLog(iQuantity + " " + LanguageConvertString(tmpLangFileID,"survivors rescued"));   //screenmessage
          PlaySound("objects\abordage\abordage_loosing.wav");   //soundeffect
          ChangeCharacterReputation(rCharacter, 1);   //rescuer deserves praise :)
		      LanguageCloseFile(tmpLangFileID);	// LDH moved line above return 19Oct06
          return false;   //aborts the function so that no "oil" goods are added
       }
       // ccc rescue survivors end
*/
// ccc Jan07 end

	if (iMaxGoodAllow == 0)
	{
		string sShipCantGotGood = LanguageConvertString(iSeaSectionLang, "Ship_cant_got_good");
		Event(PARSE_STRING, "asls", &oRes, sShipCantGotGood, 1, sGoodName);
		Log_SetStringToLog(oRes.Str);
		return false;
	}

	if (iQuantity > iMaxGoodAllow) iQuantity = iMaxGoodAllow;

	if (iCharacterIndex == GetMainCharacterIndex())
	{
		if(ENABLE_EXTRA_SOUNDS == 1) {			// added by KAM after build 11
		PlaySound("cargo_aboard"); // NK
		}						// added by KAM after build 11
		string sGoodQuantity = iQuantity * iGoodWeight;
		string sShipGotGood = LanguageConvertString(iSeaSectionLang, "Ship_got_good");
		Event(PARSE_STRING, "aslss", &oRes, sShipGotGood, 2, sGoodQuantity, sGoodName);
		Log_SetStringToLog(oRes.Str);
		trace("Got Goods: " + oRes.Str);
	}

	AddCharacterGoods(rCharacter, FindGood(sGood), iQuantity * iGoodUnits);
	return true;
}
